//
// Blinn fragment shader
//

#extension GL_EXT_bindable_uniform: enable

bindable uniform vec4 light [3];

varying	vec3 l;
varying	vec3 h;
varying vec3 v;
varying vec3 n;

void main (void)
{
	const vec4	diffColor = vec4 ( 0.5, 0.0, 0.0, 1.0 );
	const float	specPower = 30.0;

	vec3	n2   = normalize ( n );
	vec3	l2   = normalize ( l );
	vec3	h2   = normalize ( h );
	vec4	diff = diffColor * max ( dot ( n2, l2 ), 0.0 );
	vec4	spec = light [1] * pow ( max ( dot ( n2, h2 ), 0.0 ), specPower );

	gl_FragColor = diff + spec;
}
